#include "povS1.h"
#include "temp_data.h"

// Retourne VBAT en millivolts
unsigned int ReadVBAT(void) {

    unsigned int millivolts ;

    SetChanADC(CH_MVBAT);
    Delay1KTCYx( 2 ) ;
    ConvertADC();
    while( BusyADC() ) ;
    millivolts = (ReadADC() * MVBAT_RATIO)/MVBAT_FACTOR ;
    millivolts = (5000L*millivolts)/1024 ;

    return millivolts ;

}

// Retourne la temprature en dixime C

extern const rom unsigned int temp_look_up_table[] ;

int ReadTemp(void) {
    unsigned long  mean=0 ;
    unsigned int raw ;
    int i=0;
    INTCONbits.INT0E = 0 ; // pas de mise  jour des LEDs pendant la mesure !
    PIE2bits.TMR3IE = 0 ;

    THERM_ON = 1 ; // on applique la tension sur la thermistance

    SetChanADC(CH_TEMP);
    Delay1KTCYx( 20 ) ; 

    do {
        ConvertADC();
        while( BusyADC() ) ;
        raw = ReadADC();
        mean += temp_look_up_table[raw]; // accumulation des NB_MES mesures
        i= i + 1 ;
    } while ( i<TEMP_NB_MES && temp_look_up_table[raw]!=TEMP_ERROR);

    THERM_ON = 0 ;

    INTCONbits.INT0E = 1 ; // retour fonctionnement normal
    PIE2bits.TMR3IE = 1 ;

    if (i<TEMP_NB_MES)
        return TEMP_ERROR ;
    else
        return  mean/TEMP_NB_MES;
}

