#include "povS1.h"
#include "bluetooth.h"
#include "temp_data.h"
#include "stdlib.h"
extern volatile char msg[MAX_MSG+1];
extern volatile unsigned int LedsArray[60] ;
extern unsigned char hour,min,sec ;
extern unsigned int vbat ;
extern int temp ;
extern unsigned int n0, n0f, n3 , last_index, delta ;
extern long alpha ;
extern unsigned int max_it  ;
unsigned int ReadVBAT(void) ;
int ReadTemp(void);
void LedsUpdateTime(void);

// les commandes sont de la forme : C:PARAM1[:PARAM2[:PARAMx...]]]
// C est un caractre qui dfinit le type de commande
// Lorsque PARAM1 vaut ? on rpond la valeur du paramtre actuel
// Sinon Les PARAMx fixent les valeurs des paramtres
int execute_command(void) {
 
    unsigned char new_hour,new_min,new_sec ;
    int ercode = -1;  ;

  //  printf("Rx:%s\r\n",msg);
    if (msg[1] != ':') {
        printf("?\r\n$");
        return -1 ;
    }
    switch (msg[0]) {
        
        case 'H' : // cmd heure
            if ( msg[2]=='?')  { // affiche heure
                printf("H:%02d:%02d:%02d",hour,min,sec);
                ercode = 0 ;
            } else {
            // mise  l'heure
            new_hour = atoi(msg+2);
            new_min  = atoi(msg+5);
            new_sec = atoi(msg+8);
            if (new_hour<12 && new_min<60 && new_min <60) {
                    hour = new_hour ;
                    min = new_min ;
                    sec = new_sec ;
                    LedsUpdateTime();
                    printf("New time is\r\nH:%02d:%02d:%02d",hour,min,sec);
                    ercode = 0 ;
                }
            else {
                    printf("New time : %02d:%02d:%02d not valid !",\
                                                   new_hour,new_min,new_sec);
                    ercode = -1 ;
               }
            }
           
            break ;
        case 'V': // tension batterie
            if ( msg[2]=='?')  {
               vbat = ReadVBAT();
               printf("VBAT : %d mV",vbat) ;
               ercode = 0 ;
            }
            break ;
        case 'T': // temprature
             if ( msg[2]=='?')  {
               temp = ReadTemp();
               if (temp != TEMP_ERROR)  {
                  printf("Temp : %d.",temp/10) ;
                  if ( temp > 0) printf("%1d C",temp%10);
                  else printf("%1d C",(-temp)%10);
               } else
                   printf("Temp : valeur non cohrente ");
               ercode = 0 ;
            }
             break ;
        case 'R': // revision
             if ( msg[2]=='?')  {
                 printf(VERSION);
                 ercode = 0 ;
             }
             break ;
        case 'I' :  // info debug
             if ( msg[2]=='?')  {
                 printf("N0=%u N0F=%u N3=%u LastIndex=%u Delta=%u",\
                                                    n0,n0f,n3,last_index,delta);
                 ercode = 0 ;
             }
             break ;
        case 'A' :
            if ( msg[2]=='?')  {
                printf("ALPHA=%ld",alpha);
            } else {
                alpha = atoi(msg+2);
                printf("NEW ALPHA=%ld",alpha);
            }
            break ;
        case 'F': // Fast mode
            if ( msg[2]!='?')  {
                max_it=atoi(msg+2);
             }
            printf("Temps x %d",20/max_it);
            break ;
        case 'N' : // Normal mode retour temps x 1
            max_it = 20 ;
            printf("Temps x 1");
            break ;
        default :
            printf("?");
            ercode = -1 ;
    } 
    printf("\r\n$") ;
    return ercode ;

}

void LedsUpdateTime(void) {

    int i ;
    // RAZ leds
    for (i=0;i<60;i++){
        LedsArray[i]=0 ;
    }

    // Aiguilles minute et heure
    LedsArray[hour*5]=0x0FF0;
    LedsArray[min]=0x0FFF;  
    // Tour des secondes
   for (i=0;i<=sec;i++) {
      LedsArray[i]|=1;
    }
    // Ticks des 5 minutes
   for (i=0;i<60;i+=5){
       LedsArray[i]|=1;
            }
}